Index: branches/DataPreprocessing/HeuristicLab.Clients.Hive.JobManager/3.3/MenuItems/CreateHiveJobMenuItem.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Clients.Hive.JobManager/3.3/MenuItems/CreateHiveJobMenuItem.cs	(revision 10538)
+++ branches/DataPreprocessing/HeuristicLab.Clients.Hive.JobManager/3.3/MenuItems/CreateHiveJobMenuItem.cs	(revision 10538)
@@ -0,0 +1,83 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Core;
+using HeuristicLab.MainForm;
+using HeuristicLab.Optimization;
+using HeuristicLab.Optimizer;
+
+namespace HeuristicLab.Clients.Hive.JobManager {
+  public class CreateHiveJobMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItem, IOptimizerUserInterfaceItemProvider {
+    public override string Name {
+      get { return "&Create Hive Job"; }
+    }
+    public override IEnumerable<string> Structure {
+      get { return new string[] { "&Services", "&Hive" }; }
+    }
+
+    public override int Position {
+      get { return 10001; }
+    }
+
+    protected override void OnActiveViewChanged(object sender, EventArgs e) {
+      IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
+
+      if (activeView != null && activeView.Content != null && !activeView.Locked) {
+        var content = activeView.Content as IItem;
+        if (content != null) {
+          Type contentType = content.GetType();
+          ToolStripItem.Enabled = ItemTask.IsTypeSupported(contentType);
+        } else {
+          ToolStripItem.Enabled = false;
+        }
+      }
+    }
+
+    public override void Execute() {
+      IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
+      var content = activeView.Content as IItem;
+
+      //IOptimizer and IExecutables need some special care
+      if (content is IOptimizer) {
+        ((IOptimizer)content).Runs.Clear();
+      }
+      if (content is IExecutable) {
+        IExecutable exec = content as IExecutable;
+        if (exec.ExecutionState != ExecutionState.Prepared) {
+          exec.Prepare();
+        }
+      }
+
+      HiveClient.Instance.Refresh();
+
+      ItemTask hiveTask = ItemTask.GetItemTaskForItem(content);
+      HiveTask task = hiveTask.CreateHiveTask();
+      RefreshableJob rJob = new RefreshableJob();
+      rJob.Job.Name = content.ToString();
+      rJob.HiveTasks.Add(task);
+      task.ItemTask.ComputeInParallel = content is Experiment || content is BatchRun;
+
+      MainFormManager.MainForm.ShowContent(rJob);
+    }
+  }
+}
Index: branches/DataPreprocessing/HeuristicLab.Clients.Hive.JobManager/3.3/MenuItems/JobManagerMenuItem.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Clients.Hive.JobManager/3.3/MenuItems/JobManagerMenuItem.cs	(revision 10085)
+++ branches/DataPreprocessing/HeuristicLab.Clients.Hive.JobManager/3.3/MenuItems/JobManagerMenuItem.cs	(revision 10538)
@@ -22,8 +22,8 @@
 using System.Collections.Generic;
 using System.Windows.Forms;
-using HeuristicLab.Clients.Hive;
 using HeuristicLab.MainForm;
+using HeuristicLab.Optimizer;
 
-namespace HeuristicLab.Optimizer.MenuItems {
+namespace HeuristicLab.Clients.Hive.JobManager {
   public class JobManagerMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItem, IOptimizerUserInterfaceItemProvider {
     public override string Name {
Index: branches/DataPreprocessing/HeuristicLab.Clients.Hive.JobManager/3.3/MenuItems/RunInHiveMenuItem.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.Clients.Hive.JobManager/3.3/MenuItems/RunInHiveMenuItem.cs	(revision 10538)
+++ branches/DataPreprocessing/HeuristicLab.Clients.Hive.JobManager/3.3/MenuItems/RunInHiveMenuItem.cs	(revision 10538)
@@ -0,0 +1,104 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Threading;
+using HeuristicLab.Core;
+using HeuristicLab.MainForm;
+using HeuristicLab.Optimization;
+using HeuristicLab.Optimizer;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Clients.Hive.JobManager {
+  public class RunInHiveMenuItem : HeuristicLab.MainForm.WindowsForms.MenuItem, IOptimizerUserInterfaceItemProvider {
+    public override string Name {
+      get { return "&Run In Hive"; }
+    }
+    public override IEnumerable<string> Structure {
+      get { return new string[] { "&Services", "&Hive" }; }
+    }
+
+    public override int Position {
+      get { return 10002; }
+    }
+
+    protected override void OnActiveViewChanged(object sender, EventArgs e) {
+      IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
+
+      if (activeView != null && activeView.Content != null && !activeView.Locked) {
+        var content = activeView.Content as IItem;
+        if (content != null) {
+          Type contentType = content.GetType();
+          ToolStripItem.Enabled = ItemTask.IsTypeSupported(contentType);
+        } else {
+          ToolStripItem.Enabled = false;
+        }
+      }
+    }
+
+    private IProgress progress;
+    private IItem content;
+    public override void Execute() {
+      IContentView activeView = MainFormManager.MainForm.ActiveView as IContentView;
+      content = activeView.Content as IItem;
+
+      //IOptimizer and IExecutables need some special care
+      if (content is IOptimizer) {
+        ((IOptimizer)content).Runs.Clear();
+      }
+      if (content is IExecutable) {
+        IExecutable exec = content as IExecutable;
+        if (exec.ExecutionState != ExecutionState.Prepared) {
+          exec.Prepare();
+        }
+      }
+
+      HiveClient.Instance.Refresh();
+
+      ItemTask hiveTask = ItemTask.GetItemTaskForItem(content);
+      HiveTask task = hiveTask.CreateHiveTask();
+      RefreshableJob rJob = new RefreshableJob();
+      rJob.Job.Name = content.ToString();
+      rJob.HiveTasks.Add(task);
+      task.ItemTask.ComputeInParallel = content is Experiment || content is BatchRun;
+
+      progress = MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>().AddOperationProgressToContent(this.content, "Uploading to Hive...");
+      rJob.Progress = progress;
+      progress.ProgressStateChanged += progress_ProgressStateChanged;
+
+      HiveClient.StartJob(new Action<Exception>(HandleEx), rJob, new CancellationToken());
+    }
+
+    private void progress_ProgressStateChanged(object sender, EventArgs e) {
+      if (progress.ProgressState != ProgressState.Started) {
+        MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>().RemoveOperationProgressFromContent(content);
+        progress.ProgressStateChanged -= progress_ProgressStateChanged;
+      }
+    }
+
+    private void HandleEx(Exception ex) {
+      MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>().RemoveOperationProgressFromContent(content);
+      progress.ProgressStateChanged -= progress_ProgressStateChanged;
+      ErrorHandling.ShowErrorDialog("Error uploading tasks", ex);
+    }
+  }
+}
